signature CONTEXT =
sig
    structure Absyn : ABSTRACT_SYNTAX

    type tp = Absyn.tp
    type ltp = Absyn.ltp
    type support = Absyn.Support.support
		  
    datatype typing =
	Variable of tp * support
      | Name of tp

    type ctx (* = typing Var.VarMap.map *)

    val empty : ctx

    val okTp : ctx * ltp -> bool

    val find : ctx * Var.var -> typing option

    (***
     ** inserting functions do *not* check if 
     ** the inserted type is well-formed in the context 
     ***)

    val insertName : ctx * Var.var * tp -> ctx
    val insertVar : ctx * Var.var * tp * support -> ctx
    val shadowName : ctx * Var.var * Var.var -> ctx

end