structure SupportList :> 
  SUPPORT where type support = Var.var list
=
struct

    exception Error of string

    type support = Var.var list

    val empty = []
	
    fun singleton (v : Var.var) = [v]

    fun add (v, s) = (v::s)

    fun remove (v, s) = 
	(case s of
	     nil => raise Error "empty support"
	   | (v'::s') => 
		 if Var.equal (v, v') then s'
		 else raise Error "runtime error")

    fun agrees (v, s) = 
	(case s of
	     nil => false
	   | (v'::_) => Var.equal (v, v'))

    fun toString (C : support) =
	let fun printSupport ([]) = ""
	      | printSupport ([x]) = Var.toString x
	      | printSupport (x::xs) = 
		let val s = printSupport xs
		in
		    s^","^(Var.toString x)
		end
	in
	    printSupport C
	end

    fun equal (C, D) = 
        (case (C, D) of 
	     (nil, nil) => true
	   | ((x::C), (y::D)) =>
		 Var.equal (x, y) andalso equal (C, D)
	   | _ => false)

    fun leq (C, D) =
	(case C of
	     nil => true
	   | _ => equal (C, D))

    fun toList x = rev x
	
    fun fromList x = rev x

    fun isElement (v, s) = 
	(case s of
	     nil => false
	   | (vv::ss) => 
		 if Var.equal (v, vv) then true
		 else isElement (v, ss))

end
